%include "nagoa+.inc"

%macro API 2                                   ;Function , Library
	import %1 %2
	extern %1
%endmacro

API MessageBoxA,user32.dll
API GetModuleHandleA, kernel32.dll
API RegisterClassExA, user32.dll
API CreateWindowExA, user32.dll
API SetDlgItemTextA ,user32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API TranslateMessage,user32.dll
API MessageBoxA, user32.dll
API ExitProcess, kernel32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API PostQuitMessage,user32.dll
API DefWindowProcA, user32.dll
API LoadIconA,user32.dll
API LoadCursorA,user32.dll
API SendDlgItemMessageA,user32.dll
API SendMessageA, user32.dll
API SetFocus,user32.dll
API GetTextMetricsA,gdi32.dll
API CreateSolidBrush,gdi32.dll
API FillRect,user32.dll
API SetTextColor,gdi32.dll
API SetBkColor,gdi32.dll
API DeleteObject, gdi32.dll
API TextOutA,gdi32.dll
segment .data USE32
Windowhandle            	dd 0
Instance        	dd 0
label_class db "STATIC",0
list_class db "LISTBOX",0
button_class db "BUTTON",0		
Windowclassname db "OurWindowclass",0
Windowname db "color listbox",0
cursel dd 0
itm1: times 128 db 0
itm2: times 128 db 0
OurWindowclass:	
istruc WNDCLASSEX
	at WNDCLASSEX.cbSize,		dd WNDCLASSEX_size
	at WNDCLASSEX.style,		dd CS_HREDRAW|CS_VREDRAW
	at WNDCLASSEX.lpfnWndProc,	dd WindowProc
      at WNDCLASSEX.hbrBackground,	dd COLOR_BTNFACE+1
      at WNDCLASSEX.lpszClassName,	dd Windowclassname
iend

DrawItem:
istruc DRAWITEMSTRUCT
iend

Tm:
istruc TEXTMETRIC
iend

y dd 0
hBrush dd 0
LIST1_ID equ 100
ADD_BUTTON equ 101
EDIT1_ID equ 102
EDIT2_ID equ 103
LABEL1_ID equ 104

segment .bss USE32
MessageBuffer resb MSG_size
filename resb 1024
hList resd 1
hEdit resd 1
hEditNum resd 1

segment .code USE32
..start:
	call GetModuleHandleA, 0
	mov dword [Instance], eax
	loccall WinMain, [Instance], NULL,NULL, SW_SHOW
	call ExitProcess, eax

proc WinMain, hInstance, hPrevInstance, lpCmdLine, nCmdShow
	mov eax, dword [Instance]
	mov dword [OurWindowclass+WNDCLASSEX.hInstance], eax
	call LoadIconA, NULL, IDI_APPLICATION
	mov dword [OurWindowclass+WNDCLASSEX.hIcon], eax
	mov dword [OurWindowclass+WNDCLASSEX.hIconSm], eax
	call LoadCursorA, NULL, IDC_ARROW
	mov dword [OurWindowclass+WNDCLASSEX.hCursor], eax
	call RegisterClassExA,OurWindowclass
	test eax, eax
	jnz .DoAndShow
	return
	.DoAndShow:

 ;--- create and show the main program window
	call CreateWindowExA,NULL,Windowclassname,Windowname,WS_OVERLAPPED|WS_VISIBLE|WS_CAPTION|WS_MINIMIZEBOX |WS_MAXIMIZEBOX|WS_SYSMENU,300,300,300,250, NULL, NULL, [Instance], NULL
	mov dword [Windowhandle], eax
	call ShowWindow, [Windowhandle], [@nCmdShow]
	call UpdateWindow,[Windowhandle]

.loop
	call GetMessageA,MessageBuffer, NULL, 0, 0         
	cmp eax, 0
	jb .erro
	je .fin
	call TranslateMessage,MessageBuffer
	call DispatchMessageA,MessageBuffer
	jmp .loop
	.erro:
	call MessageBoxA, 0, "ERROR", "Sorry ...", MB_OK
	.fin:
	mov eax, dword[MessageBuffer+MSG.wParam]
endproc
proc WindowProc,hwnd,uMsg,wParam,lParam
	mov eax,dword[@uMsg]
	if eax,e,WM_DESTROY
		call PostQuitMessage, 0	
		xor eax,eax
		return
	endif
	if eax,e,WM_CREATE
		call CreateWindowExA, WS_EX_CLIENTEDGE,list_class,0, WS_HSCROLL|WS_VSCROLL|WS_VISIBLE|WS_CHILD|LBS_HASSTRINGS|LBS_OWNERDRAWFIXED|LBS_NOTIFY,10,10,190,200,[@hwnd], LIST1_ID, [Instance], NULL 
		mov [hList],eax
		call CreateWindowExA,NULL,button_class,"Add",WS_CHILD |WS_TABSTOP|WS_VISIBLE|BS_PUSHBUTTON,210,10,50,30,[@hwnd],ADD_BUTTON ,[Instance],NULL
		%assign .style  WS_CHILD | WS_VISIBLE 
		call CreateWindowExA, WS_EX_CLIENTEDGE, "EDIT","test",.style ,210,50,60,25,[@hwnd], EDIT1_ID, [Instance], NULL 
		mov [hEdit],eax
		%assign .style  WS_CHILD | WS_VISIBLE | ES_NUMBER
		call CreateWindowExA, WS_EX_CLIENTEDGE, "EDIT","532949",.style ,210,100,70,25,[@hwnd], EDIT2_ID, [Instance], NULL 
		mov [hEditNum],eax
		call CreateWindowExA, 0,label_class,"Color",WS_VISIBLE|WS_CHILD,210,80,50,20,[@hwnd], LABEL1_ID, [Instance], NULL 
		return
	endif
	if eax,e,WM_COMMAND
		if word [@wParam],e,ADD_BUTTON 
			call SendDlgItemMessageA,[@hwnd],EDIT1_ID,WM_GETTEXT,10,itm1
			call SendMessageA,[hList],LB_ADDSTRING,NULL,itm1
			mov [cursel],eax
			call SendDlgItemMessageA, [@hwnd], EDIT2_ID,WM_GETTEXT, 10,itm2
			str2int itm2
			call SendMessageA,[hList],LB_SETITEMDATA,[cursel],eax
			call SendMessageA,[hList],LB_SETCURSEL,[cursel],0
			call SetFocus,[hList]
			return
		endif
	endif
	if eax,e,WM_DRAWITEM
		mov esi, [@lParam]
		mov edi, DrawItem
		mov ecx, DRAWITEMSTRUCT_size
		rep movsb
		if dword[DrawItem+DRAWITEMSTRUCT.itemID],ne,-1
			call SendMessageA,[hList],LB_GETTEXT,[DrawItem+DRAWITEMSTRUCT.itemID],itm1
			push eax
			call GetTextMetricsA,[DrawItem+DRAWITEMSTRUCT.hDC],Tm
			mov eax,[DrawItem+DRAWITEMSTRUCT.rcItem+RECT.bottom]
			add eax,[DrawItem+DRAWITEMSTRUCT.rcItem+RECT.top]
			sub eax, [Tm+TEXTMETRIC.tmHeight]
			xor edx,edx
			mov ecx,2
			div ecx
			mov dword[y], eax
			mov eax,[DrawItem+DRAWITEMSTRUCT.itemState] 
			and eax,ODS_FOCUS
			if eax,ne,0
				call CreateSolidBrush,[DrawItem+DRAWITEMSTRUCT.itemData] ;000000ffh
				mov [hBrush],eax
				call FillRect,[DrawItem+DRAWITEMSTRUCT.hDC],DrawItem+DRAWITEMSTRUCT.rcItem,eax  ; NOTE NO []
				call SetTextColor,[DrawItem+DRAWITEMSTRUCT.hDC],00ffffffh ;
				call SetBkColor,[DrawItem+DRAWITEMSTRUCT.hDC],[DrawItem+DRAWITEMSTRUCT.itemData] 
				call DeleteObject,[hBrush]
			else
				call CreateSolidBrush,00FFFFFFh
				mov [hBrush],eax
				call FillRect,[DrawItem+DRAWITEMSTRUCT.hDC],DrawItem+DRAWITEMSTRUCT.rcItem,eax
				call SetTextColor,[DrawItem+DRAWITEMSTRUCT.hDC],[DrawItem+DRAWITEMSTRUCT.itemData]
				call SetBkColor,[DrawItem+DRAWITEMSTRUCT.hDC],00ffffffh
				call DeleteObject,[hBrush]
			endif        
			pop edx
			mov ecx, [DrawItem+DRAWITEMSTRUCT.rcItem+RECT.left]
			add ecx,4
			call TextOutA,[DrawItem+DRAWITEMSTRUCT.hDC],ecx,[y],itm1,edx
			xor eax,eax
			return
		endif
	endif
	defaultaction:
	call DefWindowProcA, [@hwnd], [@uMsg], [@wParam], [@lParam]
	return
endproc